import pandapower
import pandapower.networks
from tqdm import tqdm

net = pandapower.networks.case9241pegase()

res = []
for line_idx in tqdm(net.line.index):
    was_in_service = net.line.loc[line_idx, "in_service"]
    net.line.loc[line_idx, "in_service"] = False
    try:
        pandapower.rundcpp(net)
        res.append({
            "line": net.res_line.p_from_mw,
            "trafo": net.res_trafo.p_hv_mw
        })
    finally:
        net.line.loc[line_idx, "in_service"] = was_in_service


for trafo_idx in tqdm(net.trafo.index):
    was_in_service = net.trafo.loc[trafo_idx, "in_service"]
    net.trafo.loc[trafo_idx, "in_service"] = False
    try:
        pandapower.rundcpp(net)
        res.append({
            "line": net.res_line.p_from_mw,
            "trafo": net.res_trafo.p_hv_mw
        })
    finally:
        net.trafo.loc[trafo_idx, "in_service"] = was_in_service